enyo.kind({
	name: "Dialogs",
	kind: "VFlexBox",
	components: [
		{kind: "ModalDialog", name: "pref", style: "width: 400px;", caption: $L("Preferences"), components:[
			{ kind: "RowGroup", components: [ {kind: "HFlexBox", components : [ {className: "label", content: "Clean automatically"}, {kind: "CheckBox", name: "autoclean" }]}]},
			{ kind: "RowGroup", components: [ {kind: "HFlexBox", components : [ {className: "label", content: "Order by"}, {kind: "ListSelector", name: "by", items: [
        			{caption: "id", value: "id"}, {caption: "name", value: "name"}, {caption: "time left", value: "estimate"}, {caption: "progress", value: "done"}
    			]},
				{kind: "ListSelector", name: "az", items: [
        			{caption: "ascending", value: "asc"}, {caption: "descending", value: "des"}
    			]}]}
    		]},
			{layoutKind: "HFlexLayout", components: [ { kind: "Button", caption: $L("Ok"), flex: 2/3, className: "enyo-button-dark", onclick: "prefOk"},{ kind: "Button", caption: $L("Cancel"), flex: 1/3, onclick: "prefCancel"}]}
		]},
		{kind: "ModalDialog", name: "output", style: "width: 600px;", caption: $L("Result"), components:[
			{kind: "Scroller", style: "height: 300px;", components: [
				{ kind: "RowGroup", components: [{name: "stdout", className: "stdout", hint: '(stdout empty)', allowHtml: true},{name: "stderr", className: "stderr", hint: '(stderr empty)', allowHtml: true}]}
			]},
			{ layoutKind: "HFlexLayout", components: [{name: "stdcmd", className: "stdcmd", flex: 3/4}, { kind: "Button", name: "stdcode", caption: $L("Ok"), flex: 1/4, className: "enyo-button-dark", onclick: "outOk"}]}
		]},
	],
	
	create: function() {
		this.inherited(arguments);
		enyo.keyboard.setResizesWindow(false);
	},

	confirmationCancel: function(s, e) { this.$.confirmation.close(); },
	prefCancel: function(s, e) { this.$.pref.close(); },

	doPreferences: function(parent, pref) {
		this.parent = parent;
		this.pref = pref;
		this.$.pref.validateComponents();
		this.$.autoclean.setChecked(pref.autoclean);
		this.$.by.setValue(pref.orderBy);
		this.$.az.setValue(pref.orderAz);
		this.$.pref.openAtCenter();
	},
	
	prefOk: function() {
		var refreshNeeded = this.pref.orderBy != this.$.by.getValue() || this.pref.orderAz != this.$.az.getValue();
 		this.pref.autoclean = this.$.autoclean.getChecked();
 		this.pref.orderBy = this.$.by.getValue();
 		this.pref.orderAz = this.$.az.getValue();
		this.$.pref.close();
		this.doMissing(this.parent, 'Changing preferences');
//		if(refreshNeeded)
//			setTimeout(this.parent.refreshData());
	},

	doMissing: function(parent, text) {
		this.doOutput(parent, '', '{"code":0, "stdout":"'+text+'", "stderr": "Feature not implemented yet"}', false);
	},
	
	doOutput: function(parent, cmd, response, errorOnly) {
		this.parent = parent;
		try {
			var r = JSON.parse(response);
			if(errorOnly && r.code===0)
				return 0;
			this.$.output.validateComponents();
			this.$.stdcmd.setContent(cmd);
			this.$.stdout.setContent('');
			this.$.stderr.setContent('');
			if(r.stdout)
				this.$.stdout.setContent(r.stdout.replace(/[\n]/g, '<br/>'));
			if(r.stderr)
				this.$.stderr.setContent(r.stderr.replace(/[\n]/g, '<br/>'));
			if(r.error)
				this.$.stderr.setContent(r.error.replace(/[\n]/g, '<br/>'));			
			this.$.stdcode.setCaption(r.code===0 ? 'Ok' : ('Ret (' + r.code + ')'));
			this.$.output.openAtCenter();
			return r.code;
		} catch(e) {
			console.log(e + ' ### ' + response);
		}
		return undefined;
	},

	outOk: function(s, e) {
		this.$.output.close();
	}
});

