enyo.kind({
	name: "Panel",
	kind: "VFlexBox",
	published: {
		width: -1,
		index: -1,
		size: 64,
		data: undefined
	},
	components: [
		{kind: "VirtualList", name: "list", flex: 1, className: "panel", onSetupRow: "setupRow", components: [
			{kind: "Item", name: "item", className: "line", layoutKind: "VFlexLayout", onclick: "itemClick", components: [ 
				{layoutKind: "HFlexLayout", components: [
					{name: "name", className: "name", flex: 1, content: "please wait..."},
					{name: "estimate", className: "estimate"},
					{name: "done", className: "done"}
				]},
				{layoutKind: "HFlexLayout", components: [
					{name: "status", className: "status"},
					{name: "downloaded", className: "downloaded"},
					{name: "uploaded", className: "uploaded"},
					{name: "ratio", className: "ratio"},
					{name: "down", className: "down"},
					{name: "up", className: "up"},
					{name: "seeders", className: "seeders"},
					{name: "leechers", className: "leechers"}
				]},
			]}
		]}
	],

	create: function() {
		this.inherited(arguments);
	},

	rendered: function() {
		this.inherited(arguments);
	},

    resizeHandler: function() {
        this.inherited(arguments);
		this.refresh();
    },

	widthChanged: function(old) {
        this.setStyle('width:'+ this.width +'px');
	},
	
	sizeChanged: function() {
		this.refresh();		
	},
		
	dataChanged: function(oldData) {
		this.index = -1;
		var minor = oldData!==undefined && this.data!==undefined && oldData.length == this.data.length;
		for(var i=0; minor && i<this.data.length; i++)
			if(oldData[i].id!==this.data[i].id || oldData[i].name!==this.data[i].name)
				minor = false;
		if(minor)
			this.refresh();
		else {
			this.$.list.punt();
			this.$.list.reset();
		}
	},
	
	refresh: function() {
		this.timer===undefined || clearTimeout(this.timer);
		this.timer = setTimeout(this.$.list.refresh(), 50);
	},
	
	setupRow: function(inSender, inIndex) {
		if(this.data === undefined || this.data[inIndex] === undefined)
			return false;
		var item = this.data[inIndex];
//console.log('ITEM: ' + enyo.json.stringify(item));
		this.$.item.setStyle('height:' + this.size + 'px;');
		this.$.item.addRemoveClass("active", this.index===inIndex);
		this.$.name.setStyle('font-size:' + (this.size/3+4) + 'px;');
	    this.$.name.setContent(item.filename);
		this.$.status.addRemoveClass("downloading", item.status.substr(0,4)==='Down');
		this.$.status.addRemoveClass("seeding", item.status.substr(0,4)==='Seed');
		this.$.status.addRemoveClass("stopped", item.status.substr(0,4)==='Stop');
		this.$.status.addRemoveClass("finished", item.status.substr(0,4)==='Fini');
	    this.$.status.setContent(item.status);
	    this.$.downloaded.setContent(item.downloaded);
	    this.$.uploaded.setContent(item.uploaded);
	    this.$.ratio.setContent('(Ratio: '+item.ratio+')');
	    this.$.down.setContent('Down: '+item.down);
	    this.$.up.setContent('Up: '+item.up);
	    this.$.seeders.setContent('S: ' + item.seeders);
	    this.$.leechers.setContent('L: ' + item.leechers);
	    this.$.estimate.setContent(item.estimate);
	    this.$.done.setContent(item.done);
	    return true;
	},
	
	move: function(delta) {
		var idx = this.index + delta;
		if(idx>=0 && idx<this.data.length) {
			this.index = idx;
			if(idx===0)
				this.$.list.punt();
			this.refresh();
		}
	},
	
	itemClick: function(s, e) {
		var idx = e ? e.rowIndex : this.index;
		var a = this.data[idx];
		if(a===undefined)
			return;
		if(this.index === idx) {
//			this.enterClick();
		} else {
			if(this.index !== idx)
				this.index = idx;
			this.refresh();
		}
	}
});

