enyo.kind({
	name: "PdkService",
	kind: "Control",
	service: null,
	version: undefined,
	queue: [],
	components: [
		{kind: enyo.Hybrid, executable: "bin/service", onPluginConnected: "onConnected", onPluginDisconnected: "onDisconnected" }
	],
	published: {
		spinner: undefined,
		preferences: undefined
	},
		
	escapeJSON: function(str) {
	    return str
		  .replace(/[\\]/g, '\\\\')
		  .replace(/[\/]/g, '\\/')
		  .replace(/[\b]/g, '\\b')
		  .replace(/[\f]/g, '\\f')
		  .replace(/[\n]/g, '\\n')
		  .replace(/[\r]/g, '\\r')
		  .replace(/[\t]/g, '\\t');
	},

	create: function() {
		this.inherited(arguments);
	},

	onConnected: function(p) {
		this.service = p;
		this.service.addCallback('VersionCallback', this.versionCallback.bind(this), true);
	},
                                                                       
	onDisconnected: function() {
		console.warn('Disconnected!');
		this.service = null;
		this.version = null;
	},
                                  
	getVersion: function() {
		return this.version;
	},

	versionCallback: function(response) {           
		console.log('VersionCallback:' + response);
        try {
			var r = JSON.parse(response);
			if(r.v!==undefined) {
				this.version = r.v;
			}
			if(r.p!==undefined) {
				this.preferences = r.p;
			}
        } catch(e) {
            console.warn("EXCEPTION: " + e);
            this.version = -1;
        }
	},
	
	resetTimer: function() {
		this.timer===undefined || clearTimeout(this.timer);
		this.timer = setTimeout(this.handleQueue.bind(this), 100);
	},
	
	handleQueue: function(item) {
		if(item)
			console.log('HANDLE QUEUE item:' + enyo.json.stringify(item) + ', queue:' + (this.queue ? this.queue.length : 'empty'));
        if(this.service===null || this.version===null || this.working) {
            item===undefined || this.queue.push(item);
			this.resetTimer();
            return;
        }
        var i = item===undefined ? ((this.queue && this.queue.length) ? this.queue.shift() : {}) : item;
        try {
			this.working = i.cmd!==undefined;
			this.spinner && (this.working ? this.spinner.show() : this.spinner.hide());
			var cb = (this.handleCallback!==undefined && i.response!==undefined) ? this.handleCallback.bind(this, i.response) : null;
            if (i.cmd === 'shell') {
				this.service.addCallback('ShellCallback', cb, true);
                this.service.callPluginMethodDeferred(null, 'Handler', 'shell', i.arg1);
            } else if (i.cmd === 'scan') {
				this.service.addCallback('ScanCallback', cb, true);
                this.service.callPluginMethodDeferred(null, 'Handler', 'scan', i.arg1);
            }
        } catch(e) {
            console.warn("(" + i.cmd + ") EXCEPTION: " + e);
            if (e.message.indexOf("worker thread busy") >= 0 || e.message.indexOf("not allowed while") >= 0 || e.message.indexOf("has no method") >= 0 || e.message.indexOf("Cannot set property") >= 0)
				this.resetTimer();
			this.working = false;
			this.spinner && this.spinner.hide();
        }
    },

	handleCallback: function(cb, r) {
		cb.call(null, this.escapeJSON(r));
		this.working = false;
		this.spinner && this.spinner.hide();
		this.resetTimer();
	}	
});

