enyo.kind({
	name: "Torrenter",
	kind: "VFlexBox",
	components: [
		{kind: "PdkService", name: "service" },
		{kind: "PalmService", name: "opener", service: "palm://com.palm.applicationManager/", method: "open", onResponse: "openerResponse" },
		{kind: "PalmService", name: "launcher", service: "palm://com.palm.applicationManager/", method: "launch", onResponse: "launcherResponse" },
		{kind: enyo.ApplicationEvents, onWindowParamsChange: "onParamsChange", onApplicationRelaunch: "onRelaunch", onUnload: "onUnload" },
		{kind: "Toolbar", name: "top", className: "top", components: [
			{kind: "Spacer"},
//			{content: "Pref", onclick: "prefClick"},
//			{kind: "Spacer"},
			{kind: "Spinner"}
		]},
		{kind: "HFlexBox", name: "panels", flex: 1, className: "panels", components: [
			{kind: "Panel", name: "panel"}
		]},
		{kind: "Toolbar", name: "bottom", className: "bottom", components: [
//			{content: "L", onclick: "lClick"},
//			{content: "Session", onclick: "sessionClick"},
//			{content: "Open", onclick: "openClick"},
//			{content: "List", onclick: "listClick"},
			{content: "Status", onclick: "statusClick"},
//			{content: "Detail", onclick: "detailClick"},
			{content: "Clean", onclick: "cleanClick"},
			{content: "Erase", onclick: "eraseClick"},
			{content: "Start", onclick: "startClick"},
			{content: "Stop", onclick: "stopClick"}
		]},
		{kind: "Dialogs", name: "dialogs"}, 
		{kind: "Help", name: "help", onclick: "helpClick"},
		{kind: "About", name: "about", onclick: "aboutClick"},
		{kind: "AppMenu", name: "appMenu", components: [ 
			{ caption: $L("Preferences"), onclick: "prefClick" },
			{ caption: $L("Help"), onclick: "onHelp" },
			{ caption: $L("About"), onclick: "onAbout" }]}
	],
	
	escapeSh: function(str) {
		return str
			  .replace(/[\ ]/g, '\\ ')
			  .replace(/[\&]/g, '\\&')
			  .replace(/[\[]/g, '\\[')
			  .replace(/[\]]/g, '\\]')
			  .replace(/[\(]/g, '\\(')
			  .replace(/[\)]/g, '\\)');
	},

	create: function() {
		this.inherited(arguments);
		console.log('create:' + enyo.json.stringify(enyo.windowParams));
		if(enyo.windowParams && enyo.windowParams.pwd && enyo.windowParams.name && enyo.windowParams.url) {
		} else {
			this.preferences = [{autoclean: false, orderBy: 'id', orderAz: 'asc'}];
			this.$.service.setSpinner(this.$.spinner);
			enyo.keyboard.setResizesWindow(false);
			this.resizeHandler();
			setTimeout(this.callDaemon.bind(this, '-c "status all"', 1), 1000);
		}
	},

	onParamsChange: function(inSender, inEvent) {
		this.windowParams = inEvent.params;
		console.log('onParamsChange:' + enyo.json.stringify(inEvent.params));
		if(this.windowParams.target && (this.windowParams.fileName || this.windowParams.target.substr(-8).toLowerCase()==='.torrent')) {
			var path = this.windowParams.target.replace(/^file:\/\//,'');
			var dirs = path.replace(/\/+/g,'/').replace(/\/$/,'').split('/');
			dirs.pop();
			var parent = path==='/' ? '' : dirs.join('/') + '/';
			console.log('path:'+path+', parent:'+parent+', name:'+path.substr(parent.length));
			this.path = path;
			this.callDaemon('-l');		
		}
	},

	onRelaunch: function(inSender, inEvent) {
		console.log('onRelaunch:' + enyo.json.stringify(inEvent.params));
	},
	
	shellCallback: function(cmd, response) {
		console.log('ShellCallback' + response);
		var retcode = this.$.dialogs.doOutput(this, cmd, response, true);
	},
	
	onUnload: function(s, e) {},
	
	rendered: function() {
		this.inherited(arguments); 
  		var link = document.createElement("link");
		link.setAttribute("rel", "stylesheet");
  		link.setAttribute("type", "text/css");
  		link.setAttribute("href", "/media/internal/appdata/xx.torrenter/theme.css");
  		document.getElementsByTagName("head")[0].appendChild(link);
  	},

    resizeHandler: function() { 
		var width = enyo.fetchControlSize(this.$.panels).w;
		this.$.panel.setWidth(width);
    },
    
    openAppMenuHandler: function(inEvent) {
        this.$.appMenu.open();
    },
    
    onHelp: function() {
    	this.$.help.init();
    	this.$.help.openAtCenter();
    },
    
    helpClick: function() {
    	this.$.help.close();
    },

    onAbout: function() {
    	this.$.about.init();
    	this.$.about.openAtCenter();
    },
    
    aboutClick: function() {
    	this.$.about.close();
    },

	openerResponse: function(s, response) {
		console.log('OPENER:' + enyo.json.stringify(response));
	},

	launcherResponse: function(s, response) {
		console.log('LAUNCHER:' + enyo.json.stringify(response));
	},
	
	prefClick: function() {
		this.$.dialogs.doPreferences(this, this.preferences);
	},
	
	lClick: function() {
		this.callDaemon('-l');
	},

	sessionClick: function() {
		this.callDaemon('--dht --encryption -c ""', 0);
	},

	openClick: function() {
		this.callDaemon('-o /tmp/test.torrent', 1);
	},

	listClick: function() {
		this.callDaemon('-c "list"', 1);
	},

	statusClick: function() {
		this.callDaemon('-c "status all"', 1);
	},

	detailClick: function() {
		this.callDaemon('-c "status 0"', 1);
	},

	cleanClick: function() {
		if(this.findId())
			this.callDaemon('-c "clean ' + this.findId() + '"', 1);
	},

	eraseClick: function() {
		if(this.findId())
			this.callDaemon('-c "erase ' + this.findId() + '"', 1);
	},

	startClick: function() {
		if(this.findId())
			this.callDaemon('-c "start ' + this.findId() + '"', 1);
	},

	stopClick: function() {
		if(this.findId())
			this.callDaemon('-c "stop ' + this.findId() + '"', 1);
	},

	findId: function() {
		var idx = this.$.panel.getIndex();
		var item = this.data ? this.data[idx] : undefined;
		if(item && item.id)
			return item.id;
		return undefined;
	},

	callDaemon: function(action, echo) {
		if(this.$.service.getVersion() === undefined) {
console.log(' ### unknown version ### ');
			setTimeout(this.callDaemon.bind(this, action, echo), 1000);
		}
		else {
			var cmd = (echo!==undefined ? ('echo ' + echo + ' | ') : '') + 'bin/btgc --config /media/internal/appdata/xx.torrenter/client.' + this.$.service.getVersion() + ' ' + action;
			this.$.service.handleQueue({cmd:'shell', response: this.daemonCallback.bind(this, action), arg1: cmd});
		}
	},

	daemonCallback: function(action, response) {
		console.log('daemonCallback:' + response);
		if(action === '-l') {
			this.session = undefined;
			var r = JSON.parse(response);
			if(r.code === 0) {
				var arr = r.stdout.split('\n');
				if(arr.length > 1 && arr[0].substr(0,7) === 'Session')
					this.session = arr[1];
				else if(arr[0].substr(0,11) === 'No sessions')
					this.callDaemon('--dht --encryption -c ""', 0);
			}
			if(this.session && this.path)
				this.callDaemon('-o ' + this.escapeSh(this.path), 1);
		} else if(action.substr(0,5) === '--dht') {
			var r = JSON.parse(response);
			if(r.code === 0)
				this.callDaemon('-l');
		} else if(action.substr(0,2) === '-o') {
			var r = JSON.parse(response);
			if(r.code === 0) {
				var arr = r.stdout.split('\n');
				for(var i=0; i<arr.length; i++) {
					if(arr[i] === 'Response: ' && arr[i+1].substr(0,7) === 'Created')
						this.callDaemon('-c "status all"', 1);
				}
			}
		} else if(action.substr(0,2) === '-c') {
			var r = JSON.parse(response);
			if(r.code === 0) {
				var arr = r.stdout.split('\n');
				if(action.indexOf('status all') > 0) {
					this.findContexts(arr, 'Status of all contexts:', 1);
				} else if(action.indexOf('status ') > 0) {
					this.gotStatus(arr);
				} else if(action.indexOf('list') > 0) {
					this.findContexts(arr, 'Response:', 2);
				} else if(action.indexOf('stop') > 0 || action.indexOf('start') > 0  || action.indexOf('erase') > 0  || action.indexOf('clean') > 0 ) {
					this.callDaemon('-c "status all"', 1);
				}
			}
		}
		this.$.dialogs.doOutput(this, action, response, true);
	},

	findContexts: function(arr, prefix, skip) {
		this.data = [];
		for(var i=0; i<arr.length; i++) {
			if(arr[i].indexOf(prefix) === 0) {
				for(var j=i+skip; j<arr.length; j++) {
					if(arr[j].indexOf(':') > 0)
						this.callDaemon('-c "status ' + arr[j].substr(0, arr[j].indexOf(':')) + '"', 1);
					else
						break;
				}
				break;
			}
		}
//		clearTimeout(this.timeout);
//		this.timeout = setTimeout(this.callDaemon.bind(this, '-c "status all"', 1), 10*1000);
	},

	gotStatus: function(arr) {
		for(var i=0; i<arr.length; i++) {
			if(arr[i].indexOf('Response:') === 0 && i+11<arr.length) {
				var id = arr[i+2].substr(arr[i+2].indexOf(':')+2);
				var filename = arr[i+3].substr(arr[i+3].indexOf(':')+2);
				var status = arr[i+4].substr(arr[i+4].indexOf(':')+2);
				var ratio = arr[i+5].substr(arr[i+5].indexOf(':')+2);
				var estimate = "";
				if(arr[i+6].substr(0,4) === 'Time') {
					estimate = arr[i+6].substr(arr[i+6].indexOf(':')+2);
					arr.splice(i+6, 1);
				}
				var downloaded = arr[i+6].substr(arr[i+6].indexOf(':')+2);
				var uploaded = arr[i+7].substr(arr[i+7].indexOf(':')+2);
				var down = arr[i+8].substr(arr[i+8].indexOf(':')+2);
				var up = arr[i+9].substr(arr[i+9].indexOf(':')+2);
				var done = arr[i+10].substr(arr[i+10].indexOf(':')+2).replace(/\.$/,'');
				var ls = arr[i+11].substr(arr[i+11].indexOf(':')+2);
				var leechers = ls.split('/')[0];
				var seeders = ls.split('/')[1];
				var item = {id:id, filename:filename, status:status, ratio:ratio, estimate:estimate, downloaded:downloaded, uploaded:uploaded, down:down, up:up, done:done, leechers:leechers, seeders:seeders};
				this.data.push(item);
				console.log(JSON.stringify(item));
				this.$.panel.setData(this.data);				
				break;
			}
		}
	}
});

